LeetCode Longest Consecutive Sequence

Given an unsorted array of integers, find the length of the longest consecutive elements sequence.

For example,
Given [100, 4, 200, 1, 3, 2],
The longest consecutive elements sequence is [1, 2, 3, 4]. Return its length: 4.

Your algorithm should run in O(n) complexity.

解题思路:首先要注意到时间复杂度是O(n),那么问题来了,只能扫描数组一遍,显然来不及排序了(放弃排序),注意到只要返回一个整数,考虑使用map,对于遍历的数组中的数用hash存储,并且在端点保存连续的大小,在遍历下一个数时,看他的左右是否存在,若存在则更新端点的长度,否则,插入该数,如果该数在hash中,跳过。

class Solution {
public:
    int longestConsecutive(vector<int> &num) {
        int res = 0;
        unordered_map<int,int> hashMap;
        for(auto x: num)
        {
            if(!hashMap[x])//if not exit
            {
                hashMap[x] = 1 + hashMap[x-1] + hashMap[x+1];
                if(hashMap[x+1])hashMap[hashMap[x+1]+x] = hashMap[x];//update the right border
                if(hashMap[x-1])hashMap[x-hashMap[x-1]] = hashMap[x];//update the left border
            }
            res = max(res,hashMap[x]);
        }
        return res;
    }
};

 

posted @ 2014-12-10 00:58  ElephantKing  阅读(85)  评论(0编辑  收藏  举报